﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.FullScreenEvent;
	
	import flash.geom.Point;

	public class Damier extends Sprite
	{
		private static const col:int = 23;
		private static const line:int = 23;
		public static const span:int = 400 / col;
		
		private var magnet:Magnet;
		private var magnets:Array;
		private var currents:Array;
		
		private var grid:Sprite;

		public function Damier()
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		public function init(event:Event = null):void
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			magnets = new Array();
			currents = new Array();
			
			grid = new Sprite();
			addChild(grid);
			
			for(var i:Number = 0; i < col * line; i++){
				magnet = new Magnet();
				magnet.init(int(i % col) * span, int(i / col) * span);
				magnets.push(magnet);
				addChild(magnet);
			}
			
			graphics.beginFill(0x000000);
			graphics.drawRect(0,0,stage.stageWidth, stage.stageHeight);
			
			addEventListener(Event.ENTER_FRAME, enterHandler);
			addEventListener(MouseEvent.MOUSE_DOWN, downHandler);
		}
		
		private function enterHandler(e:Event):void
		{
			var i:int = 0;
			
			for (i = currents.length - 1; i >= 0; i--) {
				if (!currents[i].Run()) {
					currents.slice( i, i );
				} else {
					for(var j:int = 0; j < magnets.length; j++)	{
						magnets[j].currentMove(currents[i].x, currents[i].y, currents[i].r);
					}
				}
			}
			
			trace(magnets[0].x);
			
			grid.graphics.clear();
			grid.graphics.lineStyle(1,0xffffff);
			
			for(var k:int = 0; k < magnets.length-1; k++) {
				if((k+1)%col != 0){
					grid.graphics.moveTo(magnets[k].x, magnets[k].y);
					grid.graphics.lineTo(magnets[k+1].x, magnets[k+1].y);
				}
				/*if(k+col < col*line){
					grid.graphics.moveTo(magnets[k].x - grid.x,magnets[k].y - grid.y);
					grid.graphics.lineTo(magnets[k+col].x - grid.x,magnets[k+col].y - grid.y);
				}*/
			}
		}
		
		private function downHandler(e:MouseEvent):void
		{
			var current:Current = new Current();
			current.go(stage.mouseX, stage.mouseY);
			currents.push(current);
		}
		
		
	}
}

////////////

import flash.display.MovieClip;
import flash.events.Event;

class Magnet extends MovieClip
{
	
	public var	defX:Number;
	public var defY:Number;
	public var	effectX:Number;
	public var effectY:Number;
	
	public function Magnet():void
	{
		//graphics.beginFill(0xffffff, 1);
		//graphics.drawCircle(0,0,1);
		//graphics.endFill();
	}
	public function init(_x:Number, _y:Number):void
	{
		this.x = _x;
		this.y = _y;
		defX = _x + 120;
		defY = _y + 120;
		effectX = 0;
		effectY = 0;
		
		addEventListener(Event.ENTER_FRAME, enterHandler);
	}
	
	public function enterHandler(event:Event):void 
	{
		if ( !stage ) return;
		
		var mX:int = stage.mouseX;
		var mY:int = stage.mouseY;
		
		var len:Number = Math.sqrt( (mX - defX) * (mX - defX) + (mY - defY) * (mY - defY) );		
		var r:Number = Math.atan2( (mY - defY), (mX - defX) );
		
		var targetX:Number = defX + Math.cos(r) * 10;
		var targetY:Number = defY + Math.sin(r) * 10;
		
		targetX += effectX;
		targetY += effectY;
		
		this.x += (targetX - this.x) / 10;
		this.y += (targetY - this.y) / 10;
		
		effectX -= effectX / 50;
		effectY -= effectY / 50;
	}
	
	public function currentMove(bX:int, bY:int, bR:Number):void 
	{
		var len:Number = Math.sqrt( (defX - bX) * (defX - bX) + (defY - bY) * (defY - bY) );
		var nX:Number = (defX - bX) / len;
		var nY:Number = (defY - bY) / len;
		
		var rLen:Number = len - bR;
		if (rLen >= 0) {
			if (rLen < 50) {
				effectX += nX*2;
				effectY += nY*2;
			}
		}
	}
	
	
}

////////////

class Current extends MovieClip {
	
	var r:Number = 0;
	
	public function Current()
	{
		super();
		
		addEventListener(Event.REMOVED_FROM_STAGE, Term);
	}
	
	public function Term(event:Event):void 
	{
		removeEventListener(Event.REMOVED_FROM_STAGE, Term);
	}
	
	public function go(_x:int, _y:int):void
	{
		this.x = _x;
		this.y = _y;
		r = 0;
	}
	
	public function Run():Boolean 
	{
		r += 1;
		
		if (r >= 500) {
			return	false;
		}
		return	true;
	}
	
	
}